param($addr="192.9.187.30", $synchAddr1_2="172.16.20.2:3260", $synchAddr1_3="172.16.22.3:3260", $hbAddr1_2="172.16.10.2:3260,10.0.1.2:3260", $hbAddr1_3="172.16.12.3:3260,10.0.1.3:3260", $port=3261, $user="root", $password="starwind",
	$addr2="192.9.187.31", $synchAddr2_1="172.16.20.1:3260", $synchAddr2_3="172.16.21.3:3260", $hbAddr2_1="172.16.10.1:3260,10.0.1.1:3260", $hbAddr2_3="172.16.11.3:3260,10.0.1.3:3260", $port2=3261, $user2="root", $password2="starwind",
	$addr3="192.9.187.32", $synchAddr3_1="172.16.22.1:3260", $synchAddr3_2="172.16.21.2:3260", $hbAddr3_1="172.16.12.1:3260,10.0.1.1:3260", $hbAddr3_2="172.16.11.2:3260,10.0.1.2:3260", $port3=3261, $user3="root", $password3="starwind",
#common
	$initMethod="Clear",
	$size=200,
	$sectorSize=512,
	$failover=0,
	$bmpType=1,
	$bmpStrategy=0,
#primary node
	$imagePath="My computer\S",
	$imageName="storage",
	$createImage=$true,
	$targetAlias="Uzol1TargetAlias",
	$autoSynch=$true,
	$poolName="pool1",
	$syncSessionCount=1,
	$aluaOptimized=$true,
	$cacheMode="wb",
	$cacheSize=128,
	$syncInterface=$("#p2={0};#p3={1}" -f $synchAddr1_2,$synchAddr1_3),
	$hbInterface=$("#p2={0};#p3={1}" -f $hbAddr1_2,$hbAddr1_3),
	$bmpFolderPath="",
#secondary node
	$imagePath2="My computer\S",
	$imageName2="storage",
	$createImage2=$true,
	$targetAlias2="Uzol2TargetAlias",
	$autoSynch2=$true,
	$poolName2="pool1",
	$syncSessionCount2=1,
	$aluaOptimized2=$false,
	$cacheMode2=$cacheMode,
	$cacheSize2=$cacheSize,
	$syncInterface2=$("#p1={0};#p3={1}" -f $synchAddr2_1,$synchAddr2_3),
	$hbInterface2=$("#p1={0};#p3={1}" -f $hbAddr2_1,$hbAddr2_3),
	$bmpFolderPath2="",
#third node
	$imagePath3="My computer\S",
	$imageName3="storage",
	$createImage3=$true,
	$targetAlias3="Uzol3TargetAlias",
	$autoSynch3=$true,
	$poolName3="pool1",
	$syncSessionCount3=1,
	$aluaOptimized3=$false,
	$cacheMode3=$cacheMode,
	$cacheSize3=$cacheSize,
	$syncInterface3=$("#p1={0};#p2={1}" -f $synchAddr3_1,$synchAddr3_2),
	$hbInterface3=$("#p1={0};#p2={1}" -f $hbAddr3_1,$hbAddr3_2),
	$bmpFolderPath3=""
	)

Import-Module StarWindX

try
{
	Enable-SWXLog

	$server = New-SWServer -host $addr -port $port -user $user -password $password

	$server.Connect()
    
	$firstNode = new-Object Node

	$firstNode.HostName = $addr
	$firstNode.HostPort = $port
	$firstNode.ImagePath = $imagePath
	$firstNode.ImageName = $imageName
	$firstNode.Size = $size
	$firstNode.CreateImage = $createImage
	$firstNode.TargetAlias = $targetAlias
	$firstNode.AutoSynch = $autoSynch
	$firstNode.SyncInterface = $syncInterface
	$firstNode.HBInterface = $hbInterface
	$firstNode.PoolName = $poolName
	$firstNode.SyncSessionCount = $syncSessionCount
	$firstNode.ALUAOptimized = $aluaOptimized
	$firstNode.SectorSize = $sectorSize
	$firstNode.CacheMode = $cacheMode
	$firstNode.CacheSize = $cacheSize
	$firstNode.FailoverStrategy = $failover
	$firstNode.BitmapStoreType = $bmpType
	$firstNode.BitmapStrategy = $bmpStrategy
	$firstNode.BitmapFolderPath = $bmpFolderPath

	$secondNode = new-Object Node

	$secondNode.HostName = $addr2
	$secondNode.HostPort = $port2
	$secondNode.Login = $user2
	$secondNode.Password = $password2
	$secondNode.ImagePath = $imagePath2
	$secondNode.ImageName = $imageName2
	$secondNode.CreateImage = $createImage2
	$secondNode.TargetAlias = $targetAlias2
	$secondNode.AutoSynch = $autoSynch2
	$secondNode.SyncInterface = $syncInterface2
	$secondNode.HBInterface = $hbInterface2
	$secondNode.SyncSessionCount = $syncSessionCount2
	$secondNode.ALUAOptimized = $aluaOptimized2
	$secondNode.CacheMode = $cacheMode2
	$secondNode.CacheSize = $cacheSize2
	$secondNode.FailoverStrategy = $failover
	$secondNode.BitmapFolderPath = $bmpFolderPath2

	$thirdNode = new-Object Node

	$thirdNode.HostName = $addr3
	$thirdNode.HostPort = $port3
	$thirdNode.Login = $user3
	$thirdNode.Password = $password3
	$thirdNode.ImagePath = $imagePath3
	$thirdNode.ImageName = $imageName3
	$thirdNode.CreateImage = $createImage3
	$thirdNode.TargetAlias = $targetAlias3
	$thirdNode.AutoSynch = $autoSynch3
	$thirdNode.SyncInterface = $syncInterface3
	$thirdNode.HBInterface = $hbInterface3
	$thirdNode.SyncSessionCount = $syncSessionCount3
	$thirdNode.ALUAOptimized = $aluaOptimized3
	$thirdNode.CacheMode = $cacheMode3
	$thirdNode.CacheSize = $cacheSize3
	$thirdNode.FailoverStrategy = $failover
	$thirdNode.BitmapFolderPath = $bmpFolderPath3

	$device = Add-HADevice -server $server -firstNode $firstNode -secondNode $secondNode -thirdNode $thirdNode -initMethod $initMethod
    
	$syncState = $device.GetPropertyValue("ha_synch_status")

	while ($syncState -ne "1")
	{
		#
		# Refresh device info
		#
		$device.Refresh()

		$syncState = $device.GetPropertyValue("ha_synch_status")
		$syncPercent = $device.GetPropertyValue("ha_synch_percent")

		Start-Sleep -m 2000

		Write-Host "Synchronizing: $($syncPercent)%" -foreground yellow
	}
}
catch
{
	Write-Host $_ -foreground red
}
finally
{
	$server.Disconnect()
}
